require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_GENERIC_BITOPS_LE_H_)) {
    eval 'sub _ASM_GENERIC_BITOPS_LE_H_ () {1;}' unless defined(&_ASM_GENERIC_BITOPS_LE_H_);
    require 'asm/types.ph';
    require 'asm/byteorder.ph';
    eval 'sub BITOP_WORD {
        my($nr) = @_;
	    eval q((($nr) /  &BITS_PER_LONG));
    }' unless defined(&BITOP_WORD);
    eval 'sub BITOP_LE_SWIZZLE () {(( &BITS_PER_LONG-1) & ~0x7);}' unless defined(&BITOP_LE_SWIZZLE);
    if(defined( &__LITTLE_ENDIAN)) {
	eval 'sub generic_test_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_bit($nr, $addr));
	}' unless defined(&generic_test_le_bit);
	eval 'sub generic___set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__set_bit($nr, $addr));
	}' unless defined(&generic___set_le_bit);
	eval 'sub generic___clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__clear_bit($nr, $addr));
	}' unless defined(&generic___clear_le_bit);
	eval 'sub generic_test_and_set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_and_set_bit($nr, $addr));
	}' unless defined(&generic_test_and_set_le_bit);
	eval 'sub generic_test_and_clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_and_clear_bit($nr, $addr));
	}' unless defined(&generic_test_and_clear_le_bit);
	eval 'sub generic___test_and_set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_set_bit($nr, $addr));
	}' unless defined(&generic___test_and_set_le_bit);
	eval 'sub generic___test_and_clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit($nr, $addr));
	}' unless defined(&generic___test_and_clear_le_bit);
	eval 'sub generic_find_next_zero_le_bit {
	    my($addr, $size, $offset) = @_;
    	    eval q( &find_next_zero_bit($addr, $size, $offset));
	}' unless defined(&generic_find_next_zero_le_bit);
    }
 elsif(defined( &__BIG_ENDIAN)) {
	eval 'sub generic_test_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic_test_le_bit);
	eval 'sub generic___set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__set_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic___set_le_bit);
	eval 'sub generic___clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__clear_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic___clear_le_bit);
	eval 'sub generic_test_and_set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_and_set_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic_test_and_set_le_bit);
	eval 'sub generic_test_and_clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_and_clear_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic_test_and_clear_le_bit);
	eval 'sub generic___test_and_set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_set_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic___test_and_set_le_bit);
	eval 'sub generic___test_and_clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit(($nr) ^  &BITOP_LE_SWIZZLE, ($addr)));
	}' unless defined(&generic___test_and_clear_le_bit);
    } else {
	die("Please fix <asm/byteorder.h>");
    }
    eval 'sub generic_find_first_zero_le_bit {
        my($addr, $size) = @_;
	    eval q( &generic_find_next_zero_le_bit(($addr), ($size), 0));
    }' unless defined(&generic_find_first_zero_le_bit);
}
1;
