require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_SPARC_ATOMIC__)) {
    eval 'sub __ARCH_SPARC_ATOMIC__ () {1;}' unless defined(&__ARCH_SPARC_ATOMIC__);
    if(defined(&__KERNEL__)) {
	eval 'sub ATOMIC_INIT {
	    my($i) = @_;
    	    eval q({ ($i) });
	}' unless defined(&ATOMIC_INIT);
	eval 'sub atomic_xchg {
	    my($v, $new) = @_;
    	    eval q(( &xchg((($v)-> &counter), $new)));
	}' unless defined(&atomic_xchg);
	eval 'sub atomic_read {
	    my($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic_add {
	    my($i, $v) = @_;
    	    eval q((( &void) &__atomic_add_return( ($i), ($v))));
	}' unless defined(&atomic_add);
	eval 'sub atomic_sub {
	    my($i, $v) = @_;
    	    eval q((( &void) &__atomic_add_return(-($i), ($v))));
	}' unless defined(&atomic_sub);
	eval 'sub atomic_inc {
	    my($v) = @_;
    	    eval q((( &void) &__atomic_add_return( 1, ($v))));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_dec {
	    my($v) = @_;
    	    eval q((( &void) &__atomic_add_return( -1, ($v))));
	}' unless defined(&atomic_dec);
	eval 'sub atomic_add_return {
	    my($i, $v) = @_;
    	    eval q(( &__atomic_add_return( ($i), ($v))));
	}' unless defined(&atomic_add_return);
	eval 'sub atomic_sub_return {
	    my($i, $v) = @_;
    	    eval q(( &__atomic_add_return(-($i), ($v))));
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic_inc_return {
	    my($v) = @_;
    	    eval q(( &__atomic_add_return( 1, ($v))));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_dec_return {
	    my($v) = @_;
    	    eval q(( &__atomic_add_return( -1, ($v))));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_add_negative {
	    my($a, $v) = @_;
    	    eval q(( &atomic_add_return(($a), ($v)) < 0));
	}' unless defined(&atomic_add_negative);
	eval 'sub atomic_inc_and_test {
	    my($v) = @_;
    	    eval q(( &atomic_inc_return($v) == 0));
	}' unless defined(&atomic_inc_and_test);
	eval 'sub atomic_dec_and_test {
	    my($v) = @_;
    	    eval q(( &atomic_dec_return($v) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub atomic_sub_and_test {
	    my($i, $v) = @_;
    	    eval q(( &atomic_sub_return($i, $v) == 0));
	}' unless defined(&atomic_sub_and_test);
	eval 'sub atomic_inc_not_zero {
	    my($v) = @_;
    	    eval q( &atomic_add_unless(($v), 1, 0));
	}' unless defined(&atomic_inc_not_zero);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub ATOMIC24_INIT {
	        my($i) = @_;
    		eval q({ ($i) });
	    }' unless defined(&ATOMIC24_INIT);
	    eval 'sub atomic24_read {
	        my($v) = @_;
    		eval q((($v)-> &counter));
	    }' unless defined(&atomic24_read);
	    eval 'sub atomic24_set {
	        my($v, $i) = @_;
    		eval q(((($v)-> &counter) = $i));
	    }' unless defined(&atomic24_set);
	} else {
	    eval 'sub ATOMIC24_INIT {
	        my($i) = @_;
    		eval q({ (($i) << 8) });
	    }' unless defined(&ATOMIC24_INIT);
	    eval 'sub atomic24_read {
	        my($v) = @_;
    		eval q({ \'int\'  &ret =  ($v->{counter});  &while( &ret & 0xff)  &ret =  ($v->{counter});  &ret >> 8; });
	    }' unless defined(&atomic24_read);
	    eval 'sub atomic24_set {
	        my($v, $i) = @_;
    		eval q(((($v)-> &counter) = (($i) << 8)));
	    }' unless defined(&atomic24_set);
	}
	eval 'sub __atomic24_add {
	    my($i,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__atomic24_add);
	eval 'sub __atomic24_sub {
	    my($i,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__atomic24_sub);
	eval 'sub atomic24_add {
	    my($i, $v) = @_;
    	    eval q((( &void) &__atomic24_add(($i), ($v))));
	}' unless defined(&atomic24_add);
	eval 'sub atomic24_sub {
	    my($i, $v) = @_;
    	    eval q((( &void) &__atomic24_sub(($i), ($v))));
	}' unless defined(&atomic24_sub);
	eval 'sub atomic24_dec_return {
	    my($v) = @_;
    	    eval q( &__atomic24_sub(1, ($v)));
	}' unless defined(&atomic24_dec_return);
	eval 'sub atomic24_inc_return {
	    my($v) = @_;
    	    eval q( &__atomic24_add(1, ($v)));
	}' unless defined(&atomic24_inc_return);
	eval 'sub atomic24_sub_and_test {
	    my($i, $v) = @_;
    	    eval q(( &__atomic24_sub(($i), ($v)) == 0));
	}' unless defined(&atomic24_sub_and_test);
	eval 'sub atomic24_dec_and_test {
	    my($v) = @_;
    	    eval q(( &__atomic24_sub(1, ($v)) == 0));
	}' unless defined(&atomic24_dec_and_test);
	eval 'sub atomic24_inc {
	    my($v) = @_;
    	    eval q((( &void) &__atomic24_add(1, ($v))));
	}' unless defined(&atomic24_inc);
	eval 'sub atomic24_dec {
	    my($v) = @_;
    	    eval q((( &void) &__atomic24_sub(1, ($v))));
	}' unless defined(&atomic24_dec);
	eval 'sub atomic24_add_negative {
	    my($i, $v) = @_;
    	    eval q(( &__atomic24_add(($i), ($v)) < 0));
	}' unless defined(&atomic24_add_negative);
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
    require 'asm-generic/atomic.ph';
}
1;
