require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_HEAD_H)) {
    eval 'sub __SPARC_HEAD_H () {1;}' unless defined(&__SPARC_HEAD_H);
    eval 'sub KERNBASE () {0xf0000000;}' unless defined(&KERNBASE);
    eval 'sub LOAD_ADDR () {0x4000;}' unless defined(&LOAD_ADDR);
    eval 'sub SUN4C_SEGSZ () {(1<< 18);}' unless defined(&SUN4C_SEGSZ);
    eval 'sub SRMMU_L1_KBASE_OFFSET () {(( &KERNBASE>>24)<<2);}' unless defined(&SRMMU_L1_KBASE_OFFSET);
    eval 'sub INTS_ENAB () {0x1;}' unless defined(&INTS_ENAB);
    eval 'sub SUN4_PROM_VECTOR () {0xffe81000;}' unless defined(&SUN4_PROM_VECTOR);
    eval 'sub WRITE_PAUSE () { &nop;  &nop;  &nop;;}' unless defined(&WRITE_PAUSE);
    eval 'sub NOP_INSN () {0x1000000;}' unless defined(&NOP_INSN);
    eval 'sub TRAP_ENTRY {
        my($type, $label) = @_;
	    eval q( &rd % &psr, % &l0;  &b $label;  &rd % &wim, % &l3;  &nop;);
    }' unless defined(&TRAP_ENTRY);
    eval 'sub SPARC_TFAULT () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &sun4c_fault;  &mov 1, % &l7;;}' unless defined(&SPARC_TFAULT);
    eval 'sub SPARC_DFAULT () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &sun4c_fault;  &mov 0, % &l7;;}' unless defined(&SPARC_DFAULT);
    eval 'sub SRMMU_TFAULT () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &srmmu_fault;  &mov 1, % &l7;;}' unless defined(&SRMMU_TFAULT);
    eval 'sub SRMMU_DFAULT () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &srmmu_fault;  &mov 0, % &l7;;}' unless defined(&SRMMU_DFAULT);
    eval 'sub BAD_TRAP {
        my($num) = @_;
	    eval q( &rd % &psr, % &l0;  &mov $num, % &l7;  &b  &bad_trap_handler;  &rd % &wim, % &l3;);
    }' unless defined(&BAD_TRAP);
    eval 'sub SKIP_TRAP {
        my($type, $name) = @_;
	    eval q( &jmpl % &l2, % &g0;  &rett % &l2 + 4;  &nop;  &nop;);
    }' unless defined(&SKIP_TRAP);
    eval 'sub LINUX_SYSCALL_TRAP () { &sethi % &hi( &sys_call_table), % &l7;  &or % &l7, % &lo( &sys_call_table), % &l7;  &b  &linux_sparc_syscall;  &rd % &psr, % &l0;;}' unless defined(&LINUX_SYSCALL_TRAP);
    eval 'sub SUNOS_SYSCALL_TRAP () { &rd % &psr, % &l0;  &sethi % &hi( &sunos_sys_table), % &l7;  &b  &linux_sparc_syscall;  &or % &l7, % &lo( &sunos_sys_table), % &l7;;}' unless defined(&SUNOS_SYSCALL_TRAP);
    eval 'sub SUNOS_NO_SYSCALL_TRAP () { &b  &sunos_syscall;  &rd % &psr, % &l0;  &nop;  &nop;;}' unless defined(&SUNOS_NO_SYSCALL_TRAP);
    eval 'sub SOLARIS_SYSCALL_TRAP () { &b  &solaris_syscall;  &rd % &psr, % &l0;  &nop;  &nop;;}' unless defined(&SOLARIS_SYSCALL_TRAP);
    eval 'sub INDIRECT_SOLARIS_SYSCALL {
        my($x) = @_;
	    eval q( &mov $x, % &g1;  &b  &solaris_syscall;  &rd % &psr, % &l0;  &nop;);
    }' unless defined(&INDIRECT_SOLARIS_SYSCALL);
    eval 'sub BREAKPOINT_TRAP () { &b  &breakpoint_trap;  &rd % &psr,% &l0;  &nop;  &nop;;}' unless defined(&BREAKPOINT_TRAP);
    eval 'sub NETBSD_SYSCALL_TRAP () { &sethi % &hi( &sys_call_table), % &l7;  &or % &l7, % &lo( &sys_call_table), % &l7;  &b  &bsd_syscall;  &rd % &psr, % &l0;;}' unless defined(&NETBSD_SYSCALL_TRAP);
    eval 'sub GETCC_TRAP () { &b  &getcc_trap_handler;  &mov % &psr, % &l0;  &nop;  &nop;;}' unless defined(&GETCC_TRAP);
    eval 'sub SETCC_TRAP () { &b  &setcc_trap_handler;  &mov % &psr, % &l0;  &nop;  &nop;;}' unless defined(&SETCC_TRAP);
    eval 'sub GETPSR_TRAP () { &mov % &psr, % &i0;  &jmp % &l2;  &rett % &l2 + 4;  &nop;;}' unless defined(&GETPSR_TRAP);
    eval 'sub TRAP_ENTRY_INTERRUPT {
        my($int_level) = @_;
	    eval q( &mov $int_level, % &l7;  &rd % &psr, % &l0;  &b  &real_irq_entry;  &rd % &wim, % &l3;);
    }' unless defined(&TRAP_ENTRY_INTERRUPT);
    eval 'sub NMI_TRAP () { &rd % &wim, % &l3;  &b  &linux_trap_nmi_sun4c;  &mov % &psr, % &l0;  &nop;;}' unless defined(&NMI_TRAP);
    eval 'sub WINDOW_SPILL () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &spill_window_entry;  &andcc % &l0,  &PSR_PS, % &g0;;}' unless defined(&WINDOW_SPILL);
    eval 'sub WINDOW_FILL () { &rd % &psr, % &l0;  &rd % &wim, % &l3;  &b  &fill_window_entry;  &andcc % &l0,  &PSR_PS, % &g0;;}' unless defined(&WINDOW_FILL);
}
1;
