require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_SYSTEM_H)) {
    eval 'sub __SPARC_SYSTEM_H () {1;}' unless defined(&__SPARC_SYSTEM_H);
    require 'linux/kernel.ph';
    require 'linux/threads.ph';
    require 'linux/thread_info.ph';
    require 'asm/page.ph';
    require 'asm/psr.ph';
    require 'asm/ptrace.ph';
    require 'asm/btfixup.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval("sub sun4 () { 0x00; }") unless defined(&sun4);
	eval("sub sun4c () { 0x01; }") unless defined(&sun4c);
	eval("sub sun4m () { 0x02; }") unless defined(&sun4m);
	eval("sub sun4d () { 0x03; }") unless defined(&sun4d);
	eval("sub sun4e () { 0x04; }") unless defined(&sun4e);
	eval("sub sun4u () { 0x05; }") unless defined(&sun4u);
	eval("sub sun_unknown () { 0x06; }") unless defined(&sun_unknown);
	eval("sub ap1000 () { 0x07; }") unless defined(&ap1000);
	if(defined(&__KERNEL__)) {
	    unless(defined(&CONFIG_SUN4)) {
		eval 'sub ARCH_SUN4C_SUN4 () {( &sparc_cpu_model== &sun4c);}' unless defined(&ARCH_SUN4C_SUN4);
		eval 'sub ARCH_SUN4 () {0;}' unless defined(&ARCH_SUN4);
	    } else {
		eval 'sub ARCH_SUN4C_SUN4 () {1;}' unless defined(&ARCH_SUN4C_SUN4);
		eval 'sub ARCH_SUN4 () {1;}' unless defined(&ARCH_SUN4);
	    }
	    eval 'sub SUN4M_NCPUS () {4;}' unless defined(&SUN4M_NCPUS);
	    eval 'sub con_is_present {
	        my($void) = @_;
    		eval q({  &serial_console ? 0: 1; });
	    }' unless defined(&con_is_present);
	    if(defined(&CONFIG_SMP)) {
		eval 'sub SWITCH_ENTER {
		    my($prv) = @_;
    		    eval q( &do {  &if ( &test_tsk_thread_flag($prv,  &TIF_USEDFPU)) {  &put_psr( &get_psr() |  &PSR_EF);  &fpsave(($prv)-> ($thread->{float_regs[0]}), ($prv)-> ($thread->{fsr}), ($prv)-> ($thread->{fpqueue[0]}), ($prv)-> ($thread->{fpqdepth}));  &clear_tsk_thread_flag($prv,  &TIF_USEDFPU); ($prv)-> ($thread->{kregs}->{psr}) &= ~ &PSR_EF; } }  &while(0));
		}' unless defined(&SWITCH_ENTER);
		eval 'sub SWITCH_DO_LAZY_FPU {
		    my($next) = @_;
    		    eval q();
		}' unless defined(&SWITCH_DO_LAZY_FPU);
	    } else {
		eval 'sub SWITCH_ENTER {
		    my($prv) = @_;
    		    eval q();
		}' unless defined(&SWITCH_ENTER);
		eval 'sub SWITCH_DO_LAZY_FPU {
		    my($nxt) = @_;
    		    eval q( &do {  &if ( &last_task_used_math != ($nxt)) ($nxt)-> ($thread->{kregs}->{psr})&=~ &PSR_EF; }  &while(0));
		}' unless defined(&SWITCH_DO_LAZY_FPU);
	    }
	    eval 'sub prepare_arch_switch {
	        my($next) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&prepare_arch_switch);
	    eval 'sub switch_to {
	        my($prev, $next, $last) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&switch_to);
	    eval 'sub getipl {
	        my($void) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&getipl);
	    eval 'sub local_save_flags {
	        my($flags) = @_;
    		eval q((($flags) =  &getipl()));
	    }' unless defined(&local_save_flags);
	    eval 'sub local_irq_save {
	        my($flags) = @_;
    		eval q((($flags) =  &__local_irq_save()));
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q((( &void)  &__local_irq_save()));
	    }' unless defined(&local_irq_disable);
	    eval 'sub irqs_disabled () {
	        eval q((( &getipl() &  &PSR_PIL) != 0));
	    }' unless defined(&irqs_disabled);
	    eval 'sub mb () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&mb);
	    eval 'sub rmb () {
	        eval q( &mb());
	    }' unless defined(&rmb);
	    eval 'sub wmb () {
	        eval q( &mb());
	    }' unless defined(&wmb);
	    eval 'sub read_barrier_depends () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&read_barrier_depends);
	    eval 'sub set_mb {
	        my($__var, $__value) = @_;
    		eval q( &do { $__var = $__value;  &mb(); }  &while(0));
	    }' unless defined(&set_mb);
	    eval 'sub smp_mb () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&smp_read_barrier_depends);
	    eval 'sub nop () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&nop);
	    unless(defined(&CONFIG_SMP)) {
	    }
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub xchg_u32 {
	        my($m,$val) = @_;
    		eval q({ });
	    }' unless defined(&xchg_u32);
	    eval 'sub xchg {
	        my($ptr,$x) = @_;
    		eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	    }' unless defined(&xchg);
	    eval 'sub tas {
	        my($ptr) = @_;
    		eval q(( &xchg(($ptr),1)));
	    }' unless defined(&tas);
	    eval 'sub __xchg {
	        my($x,$ptr,$size) = @_;
    		eval q({  &switch ($size) {  &case 4:  &xchg_u32($ptr, $x); };  &__xchg_called_with_bad_pointer(); $x; });
	    }' unless defined(&__xchg);
	}
    }
    eval 'sub arch_align_stack {
        my($x) = @_;
	    eval q(($x));
    }' unless defined(&arch_align_stack);
}
1;
