require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_UACCESS_H)) {
    eval 'sub _ASM_UACCESS_H () {1;}' unless defined(&_ASM_UACCESS_H);
    if(defined(&__KERNEL__)) {
	require 'linux/compiler.ph';
	require 'linux/sched.ph';
	require 'linux/string.ph';
	require 'linux/errno.ph';
	require 'asm/vac-ops.ph';
	require 'asm/a.out.ph';
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0});}' unless defined(&KERNEL_DS);
	eval 'sub USER_DS () {(( &mm_segment_t) { -1});}' unless defined(&USER_DS);
	eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
	eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
	eval 'sub get_ds () {
	    eval q(( &KERNEL_DS));
	}' unless defined(&get_ds);
	eval 'sub get_fs () {
	    eval q(( ($current->{thread}->{current_ds})));
	}' unless defined(&get_fs);
	eval 'sub set_fs {
	    my($val) = @_;
    	    eval q((( ($current->{thread}->{current_ds})) = ($val)));
	}' unless defined(&set_fs);
	eval 'sub segment_eq {
	    my($a,$b) = @_;
    	    eval q((($a). &seg == ($b). &seg));
	}' unless defined(&segment_eq);
	eval 'sub __user_ok {
	    my($addr, $size) = @_;
    	    eval q(({ ( &void)($size); ($addr) <  &STACK_TOP; }));
	}' unless defined(&__user_ok);
	eval 'sub __kernel_ok () {( &segment_eq( &get_fs(),  &KERNEL_DS));}' unless defined(&__kernel_ok);
	eval 'sub __access_ok {
	    my($addr,$size) = @_;
    	    eval q(( &__user_ok(($addr) &  &get_fs(). &seg,($size))));
	}' unless defined(&__access_ok);
	eval 'sub access_ok {
	    my($type, $addr, $size) = @_;
    	    eval q(({ ( &void);  &__access_ok(($addr), $size); }));
	}' unless defined(&access_ok);
	eval 'sub put_user {
	    my($x,$ptr) = @_;
    	    eval q(({ \'unsigned long __pu_addr\' = ($ptr);  &__chk_user_ptr($ptr);  &__put_user_check(( &__typeof__(*($ptr)))($x), &__pu_addr,$sizeof{($ptr)}); }));
	}' unless defined(&put_user);
	eval 'sub get_user {
	    my($x,$ptr) = @_;
    	    eval q(({ \'unsigned long __gu_addr\' = ($ptr);  &__chk_user_ptr($ptr);  &__get_user_check(($x), &__gu_addr,$sizeof{($ptr)}, &__typeof__(*($ptr))); }));
	}' unless defined(&get_user);
	eval 'sub __put_user {
	    my($x,$ptr) = @_;
    	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
	}' unless defined(&__put_user);
	eval 'sub __get_user {
	    my($x,$ptr) = @_;
    	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}, &__typeof__(*($ptr))));
	}' unless defined(&__get_user);
	eval 'sub __m {
	    my($x) = @_;
    	    eval q(((1;
	}' unless defined(&__m);
	eval 'sub __put_user_check {
	    my($x,$addr,$size) = @_;
    	    eval q(({  &register \'int\'  &__pu_ret;  &if ( &__access_ok($addr,$size)) {  &switch ($size) {  &case 1:  &__put_user_asm($x, &b,$addr, &__pu_ret);  &break;  &case 2:  &__put_user_asm($x, &h,$addr, &__pu_ret);  &break;  &case 4:  &__put_user_asm($x,,$addr, &__pu_ret);  &break;  &case 8:  &__put_user_asm($x, &d,$addr, &__pu_ret);  &break;  &default:  &__pu_ret =  &__put_user_bad();  &break; } }  &else {  &__pu_ret = - &EFAULT; }  &__pu_ret; }));
	}' unless defined(&__put_user_check);
	eval 'sub __put_user_nocheck {
	    my($x,$addr,$size) = @_;
    	    eval q(({  &register \'int\'  &__pu_ret;  &switch ($size) {  &case 1:  &__put_user_asm($x, &b,$addr, &__pu_ret);  &break;  &case 2:  &__put_user_asm($x, &h,$addr, &__pu_ret);  &break;  &case 4:  &__put_user_asm($x,,$addr, &__pu_ret);  &break;  &case 8:  &__put_user_asm($x, &d,$addr, &__pu_ret);  &break;  &default:  &__pu_ret =  &__put_user_bad();  &break; }  &__pu_ret; }));
	}' unless defined(&__put_user_nocheck);
	eval 'sub __put_user_asm {
	    my($x,$size,$addr,$ret) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_asm);
	eval 'sub __get_user_check {
	    my($x,$addr,$size,$type) = @_;
    	    eval q(({  &register \'int\'  &__gu_ret;  &register \'unsigned long __gu_val\';  &if ( &__access_ok($addr,$size)) {  &switch ($size) {  &case 1:  &__get_user_asm( &__gu_val, &ub,$addr, &__gu_ret);  &break;  &case 2:  &__get_user_asm( &__gu_val, &uh,$addr, &__gu_ret);  &break;  &case 4:  &__get_user_asm( &__gu_val,,$addr, &__gu_ret);  &break;  &case 8:  &__get_user_asm( &__gu_val, &d,$addr, &__gu_ret);  &break;  &default:  &__gu_val = 0;  &__gu_ret =  &__get_user_bad();  &break; } }  &else {  &__gu_val = 0;  &__gu_ret = - &EFAULT; } $x = ($type)  &__gu_val;  &__gu_ret; }));
	}' unless defined(&__get_user_check);
	eval 'sub __get_user_check_ret {
	    my($x,$addr,$size,$type,$retval) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_check_ret);
	eval 'sub __get_user_nocheck {
	    my($x,$addr,$size,$type) = @_;
    	    eval q(({  &register \'int\'  &__gu_ret;  &register \'unsigned long __gu_val\';  &switch ($size) {  &case 1:  &__get_user_asm( &__gu_val, &ub,$addr, &__gu_ret);  &break;  &case 2:  &__get_user_asm( &__gu_val, &uh,$addr, &__gu_ret);  &break;  &case 4:  &__get_user_asm( &__gu_val,,$addr, &__gu_ret);  &break;  &case 8:  &__get_user_asm( &__gu_val, &d,$addr, &__gu_ret);  &break;  &default:  &__gu_val = 0;  &__gu_ret =  &__get_user_bad();  &break; } $x = ($type)  &__gu_val;  &__gu_ret; }));
	}' unless defined(&__get_user_nocheck);
	eval 'sub __get_user_nocheck_ret {
	    my($x,$addr,$size,$type,$retval) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_nocheck_ret);
	eval 'sub __get_user_asm {
	    my($x,$size,$addr,$ret) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_asm);
	eval 'sub __get_user_asm_ret {
	    my($x,$size,$addr,$retval) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_user_asm_ret);
	eval 'sub copy_to_user {
	    my($to,$from,$n) = @_;
    	    eval q({  &if ($n  &&  &__access_ok( $to, $n))  &__copy_user($to, ( &__force  &void  &__user *) $from, $n);  &else $n; });
	}' unless defined(&copy_to_user);
	eval 'sub __copy_to_user {
	    my($to,$from,$n) = @_;
    	    eval q({  &__copy_user($to, ( &__force  &void  &__user *) $from, $n); });
	}' unless defined(&__copy_to_user);
	eval 'sub copy_from_user {
	    my($to,$from,$n) = @_;
    	    eval q({  &if ($n  &&  &__access_ok( $from, $n))  &__copy_user(( &__force  &void  &__user *) $to, $from, $n);  &else $n; });
	}' unless defined(&copy_from_user);
	eval 'sub __copy_from_user {
	    my($to,$from,$n) = @_;
    	    eval q({  &__copy_user(( &__force  &void  &__user *) $to, $from, $n); });
	}' unless defined(&__copy_from_user);
	eval 'sub __copy_to_user_inatomic () { &__copy_to_user;}' unless defined(&__copy_to_user_inatomic);
	eval 'sub __copy_from_user_inatomic () { &__copy_from_user;}' unless defined(&__copy_from_user_inatomic);
	eval 'sub __clear_user {
	    my($addr,$size) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__clear_user);
	eval 'sub clear_user {
	    my($addr,$n) = @_;
    	    eval q({  &if ($n  &&  &__access_ok( $addr, $n))  &__clear_user($addr, $n);  &else $n; });
	}' unless defined(&clear_user);
	eval 'sub strncpy_from_user {
	    my($dest,$src,$count) = @_;
    	    eval q({  &if ( &__access_ok( $src, $count))  &__strncpy_from_user($dest, $src, $count);  &else - &EFAULT; });
	}' unless defined(&strncpy_from_user);
	eval 'sub strlen_user {
	    my($str) = @_;
    	    eval q({  &if (! &access_ok( &VERIFY_READ, $str, 0)) 0;  &else  &__strlen_user($str); });
	}' unless defined(&strlen_user);
	eval 'sub strnlen_user {
	    my($str,$len) = @_;
    	    eval q({  &if (! &access_ok( &VERIFY_READ, $str, 0)) 0;  &else  &__strnlen_user($str, $len); });
	}' unless defined(&strnlen_user);
    }
}
1;
