require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_SPARC64_ATOMIC__)) {
    eval 'sub __ARCH_SPARC64_ATOMIC__ () {1;}' unless defined(&__ARCH_SPARC64_ATOMIC__);
    require 'linux/types.ph';
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC_INIT);
    eval 'sub ATOMIC64_INIT {
        my($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC64_INIT);
    eval 'sub atomic_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic_read);
    eval 'sub atomic64_read {
        my($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic64_read);
    eval 'sub atomic_set {
        my($v, $i) = @_;
	    eval q(((($v)-> &counter) = $i));
    }' unless defined(&atomic_set);
    eval 'sub atomic64_set {
        my($v, $i) = @_;
	    eval q(((($v)-> &counter) = $i));
    }' unless defined(&atomic64_set);
    eval 'sub atomic_dec_return {
        my($v) = @_;
	    eval q( &atomic_sub_ret(1, $v));
    }' unless defined(&atomic_dec_return);
    eval 'sub atomic64_dec_return {
        my($v) = @_;
	    eval q( &atomic64_sub_ret(1, $v));
    }' unless defined(&atomic64_dec_return);
    eval 'sub atomic_inc_return {
        my($v) = @_;
	    eval q( &atomic_add_ret(1, $v));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic64_inc_return {
        my($v) = @_;
	    eval q( &atomic64_add_ret(1, $v));
    }' unless defined(&atomic64_inc_return);
    eval 'sub atomic_sub_return {
        my($i, $v) = @_;
	    eval q( &atomic_sub_ret($i, $v));
    }' unless defined(&atomic_sub_return);
    eval 'sub atomic64_sub_return {
        my($i, $v) = @_;
	    eval q( &atomic64_sub_ret($i, $v));
    }' unless defined(&atomic64_sub_return);
    eval 'sub atomic_add_return {
        my($i, $v) = @_;
	    eval q( &atomic_add_ret($i, $v));
    }' unless defined(&atomic_add_return);
    eval 'sub atomic64_add_return {
        my($i, $v) = @_;
	    eval q( &atomic64_add_ret($i, $v));
    }' unless defined(&atomic64_add_return);
    eval 'sub atomic_inc_and_test {
        my($v) = @_;
	    eval q(( &atomic_inc_return($v) == 0));
    }' unless defined(&atomic_inc_and_test);
    eval 'sub atomic64_inc_and_test {
        my($v) = @_;
	    eval q(( &atomic64_inc_return($v) == 0));
    }' unless defined(&atomic64_inc_and_test);
    eval 'sub atomic_sub_and_test {
        my($i, $v) = @_;
	    eval q(( &atomic_sub_ret($i, $v) == 0));
    }' unless defined(&atomic_sub_and_test);
    eval 'sub atomic64_sub_and_test {
        my($i, $v) = @_;
	    eval q(( &atomic64_sub_ret($i, $v) == 0));
    }' unless defined(&atomic64_sub_and_test);
    eval 'sub atomic_dec_and_test {
        my($v) = @_;
	    eval q(( &atomic_sub_ret(1, $v) == 0));
    }' unless defined(&atomic_dec_and_test);
    eval 'sub atomic64_dec_and_test {
        my($v) = @_;
	    eval q(( &atomic64_sub_ret(1, $v) == 0));
    }' unless defined(&atomic64_dec_and_test);
    eval 'sub atomic_inc {
        my($v) = @_;
	    eval q( &atomic_add(1, $v));
    }' unless defined(&atomic_inc);
    eval 'sub atomic64_inc {
        my($v) = @_;
	    eval q( &atomic64_add(1, $v));
    }' unless defined(&atomic64_inc);
    eval 'sub atomic_dec {
        my($v) = @_;
	    eval q( &atomic_sub(1, $v));
    }' unless defined(&atomic_dec);
    eval 'sub atomic64_dec {
        my($v) = @_;
	    eval q( &atomic64_sub(1, $v));
    }' unless defined(&atomic64_dec);
    eval 'sub atomic_add_negative {
        my($i, $v) = @_;
	    eval q(( &atomic_add_ret($i, $v) < 0));
    }' unless defined(&atomic_add_negative);
    eval 'sub atomic64_add_negative {
        my($i, $v) = @_;
	    eval q(( &atomic64_add_ret($i, $v) < 0));
    }' unless defined(&atomic64_add_negative);
    eval 'sub atomic_cmpxchg {
        my($v, $o, $n) = @_;
	    eval q(( &cmpxchg((($v)-> &counter), ($o), ($n))));
    }' unless defined(&atomic_cmpxchg);
    eval 'sub atomic_xchg {
        my($v, $new) = @_;
	    eval q(( &xchg((($v)-> &counter), $new)));
    }' unless defined(&atomic_xchg);
    eval 'sub atomic_add_unless {
        my($v, $a, $u) = @_;
	    eval q(({ \'int\'  &c,  &old;  &c =  &atomic_read($v);  &for (;;) {  &if ( &unlikely( &c == ($u)))  &break;  &old =  &atomic_cmpxchg(($v),  &c,  &c + ($a));  &if ( &likely( &old ==  &c))  &break;  &c =  &old; }  &likely( &c != ($u)); }));
    }' unless defined(&atomic_add_unless);
    eval 'sub atomic_inc_not_zero {
        my($v) = @_;
	    eval q( &atomic_add_unless(($v), 1, 0));
    }' unless defined(&atomic_inc_not_zero);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &membar_storeload_loadload(););
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &membar_storeload_storestore(););
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &membar_storeload_loadload(););
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &membar_storeload_storestore(););
	}' unless defined(&smp_mb__after_atomic_inc);
    } else {
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
    require 'asm-generic/atomic.ph';
}
1;
