require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_BITOPS_H)) {
    eval 'sub _SPARC64_BITOPS_H () {1;}' unless defined(&_SPARC64_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/byteorder.ph';
    require 'asm-generic/bitops/non-atomic.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &membar_storeload_loadload());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &membar_storeload_storestore());
	}' unless defined(&smp_mb__after_clear_bit);
    } else {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_clear_bit);
    }
    require 'asm-generic/bitops/ffz.ph';
    require 'asm-generic/bitops/__ffs.ph';
    require 'asm-generic/bitops/fls.ph';
    require 'asm-generic/bitops/fls64.ph';
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/sched.ph';
	require 'asm-generic/bitops/ffs.ph';
	if(defined(&ULTRA_HAS_POPULATION_COUNT)) {
	    eval 'sub hweight64 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight64);
	    eval 'sub hweight32 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight8);
	} else {
	    require 'asm-generic/bitops/hweight.ph';
	}
    }
    require 'asm-generic/bitops/find.ph';
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/ext2-non-atomic.ph';
	eval 'sub ext2_set_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_set_bit( ^ 0x38,($addr)));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_clear_bit( ^ 0x38,($addr)));
	}' unless defined(&ext2_clear_bit_atomic);
	require 'asm-generic/bitops/minix.ph';
    }
}
1;
