require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_CPUDATA_H)) {
    eval 'sub _SPARC64_CPUDATA_H () {1;}' unless defined(&_SPARC64_CPUDATA_H);
    require 'asm/hypervisor.ph';
    require 'asm/asi.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/percpu.ph';
	require 'linux/threads.ph';
	eval 'sub cpu_data {
	    my($__cpu) = @_;
    	    eval q( &per_cpu( &__cpu_data, ($__cpu)));
	}' unless defined(&cpu_data);
	eval 'sub local_cpu_data () {
	    eval q( &__get_cpu_var( &__cpu_data));
	}' unless defined(&local_cpu_data);
    }
    eval 'sub TRAP_PER_CPU_THREAD () {0x;}' unless defined(&TRAP_PER_CPU_THREAD);
    eval 'sub TRAP_PER_CPU_PGD_PADDR () {0x8;}' unless defined(&TRAP_PER_CPU_PGD_PADDR);
    eval 'sub TRAP_PER_CPU_CPU_MONDO_PA () {0x10;}' unless defined(&TRAP_PER_CPU_CPU_MONDO_PA);
    eval 'sub TRAP_PER_CPU_DEV_MONDO_PA () {0x18;}' unless defined(&TRAP_PER_CPU_DEV_MONDO_PA);
    eval 'sub TRAP_PER_CPU_RESUM_MONDO_PA () {0x20;}' unless defined(&TRAP_PER_CPU_RESUM_MONDO_PA);
    eval 'sub TRAP_PER_CPU_RESUM_KBUF_PA () {0x28;}' unless defined(&TRAP_PER_CPU_RESUM_KBUF_PA);
    eval 'sub TRAP_PER_CPU_NONRESUM_MONDO_PA () {0x30;}' unless defined(&TRAP_PER_CPU_NONRESUM_MONDO_PA);
    eval 'sub TRAP_PER_CPU_NONRESUM_KBUF_PA () {0x38;}' unless defined(&TRAP_PER_CPU_NONRESUM_KBUF_PA);
    eval 'sub TRAP_PER_CPU_FAULT_INFO () {0x40;}' unless defined(&TRAP_PER_CPU_FAULT_INFO);
    eval 'sub TRAP_PER_CPU_CPU_MONDO_BLOCK_PA () {0xc0;}' unless defined(&TRAP_PER_CPU_CPU_MONDO_BLOCK_PA);
    eval 'sub TRAP_PER_CPU_CPU_LIST_PA () {0xc8;}' unless defined(&TRAP_PER_CPU_CPU_LIST_PA);
    eval 'sub TRAP_PER_CPU_TSB_HUGE () {0xd0;}' unless defined(&TRAP_PER_CPU_TSB_HUGE);
    eval 'sub TRAP_PER_CPU_TSB_HUGE_TEMP () {0xd8;}' unless defined(&TRAP_PER_CPU_TSB_HUGE_TEMP);
    eval 'sub TRAP_PER_CPU_IRQ_WORKLIST () {0xe0;}' unless defined(&TRAP_PER_CPU_IRQ_WORKLIST);
    eval 'sub TRAP_BLOCK_SZ_SHIFT () {8;}' unless defined(&TRAP_BLOCK_SZ_SHIFT);
    require 'asm/scratchpad.ph';
    eval 'sub __GET_CPUID {
        my($REG) = @_;
	    eval q(661:  &ldxa [% &g0]  &ASI_UPA_CONFIG, $REG;  &srlx $REG, 17, $REG;  &and $REG, 0x1f, $REG;  &nop; . &section . &cpuid_patch, \\"ax\\"; . &word 661 &b;  &ldxa [% &g0]  &ASI_SAFARI_CONFIG, $REG;  &srlx $REG, 17, $REG;  &and $REG, 0x3ff, $REG;  &nop;  &ldxa [% &g0]  &ASI_JBUS_CONFIG, $REG;  &srlx $REG, 17, $REG;  &and $REG, 0x1f, $REG;  &nop;  &sethi % &hi(2198821929168 >> 9), $REG;  &sllx $REG, 9, $REG;  &or $REG, 0xd0, $REG;  &lduwa [$REG]  &ASI_PHYS_BYPASS_EC_E, $REG;  &mov  &SCRATCHPAD_CPUID, $REG;  &ldxa [$REG]  &ASI_SCRATCHPAD, $REG;  &nop;  &nop; . &previous;);
    }' unless defined(&__GET_CPUID);
    if(defined(&CONFIG_SMP)) {
	eval 'sub TRAP_LOAD_TRAP_BLOCK {
	    my($DEST, $TMP) = @_;
    	    eval q( &__GET_CPUID($TMP)  &sethi % &hi( &trap_block), $DEST;  &sllx $TMP,  &TRAP_BLOCK_SZ_SHIFT, $TMP;  &or $DEST, % &lo( &trap_block), $DEST;  &add $DEST, $TMP, $DEST;);
	}' unless defined(&TRAP_LOAD_TRAP_BLOCK);
	eval 'sub TRAP_LOAD_PGD_PHYS {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &ldx [$DEST +  &TRAP_PER_CPU_PGD_PADDR], $DEST;);
	}' unless defined(&TRAP_LOAD_PGD_PHYS);
	eval 'sub TRAP_LOAD_IRQ_WORK {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &add $DEST,  &TRAP_PER_CPU_IRQ_WORKLIST, $DEST;);
	}' unless defined(&TRAP_LOAD_IRQ_WORK);
	eval 'sub TRAP_LOAD_THREAD_REG {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &ldx [$DEST +  &TRAP_PER_CPU_THREAD], $DEST;);
	}' unless defined(&TRAP_LOAD_THREAD_REG);
	eval 'sub LOAD_PER_CPU_BASE {
	    my($DEST, $THR, $REG1, $REG2, $REG3) = @_;
    	    eval q( &ldub [$THR +  &TI_CPU], $REG1;  &sethi % &hi( &__per_cpu_shift), $REG3;  &sethi % &hi( &__per_cpu_base), $REG2;  &ldx [$REG3 + % &lo( &__per_cpu_shift)], $REG3;  &ldx [$REG2 + % &lo( &__per_cpu_base)], $REG2;  &sllx $REG1, $REG3, $REG3;  &add $REG3, $REG2, $DEST;);
	}' unless defined(&LOAD_PER_CPU_BASE);
    } else {
	eval 'sub TRAP_LOAD_TRAP_BLOCK {
	    my($DEST, $TMP) = @_;
    	    eval q( &sethi % &hi( &trap_block), $DEST;  &or $DEST, % &lo( &trap_block), $DEST;);
	}' unless defined(&TRAP_LOAD_TRAP_BLOCK);
	eval 'sub TRAP_LOAD_PGD_PHYS {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &ldx [$DEST +  &TRAP_PER_CPU_PGD_PADDR], $DEST;);
	}' unless defined(&TRAP_LOAD_PGD_PHYS);
	eval 'sub TRAP_LOAD_IRQ_WORK {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &add $DEST,  &TRAP_PER_CPU_IRQ_WORKLIST, $DEST;);
	}' unless defined(&TRAP_LOAD_IRQ_WORK);
	eval 'sub TRAP_LOAD_THREAD_REG {
	    my($DEST, $TMP) = @_;
    	    eval q( &TRAP_LOAD_TRAP_BLOCK($DEST, $TMP)  &ldx [$DEST +  &TRAP_PER_CPU_THREAD], $DEST;);
	}' unless defined(&TRAP_LOAD_THREAD_REG);
	eval 'sub LOAD_PER_CPU_BASE {
	    my($DEST, $THR, $REG1, $REG2, $REG3) = @_;
    	    eval q();
	}' unless defined(&LOAD_PER_CPU_BASE);
    }
}
1;
