require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__MMU_H)) {
    eval 'sub __MMU_H () {1;}' unless defined(&__MMU_H);
    require 'asm/page.ph';
    require 'asm/const.ph';
    require 'asm/hypervisor.ph';
    eval 'sub CTX_NR_BITS () {13;}' unless defined(&CTX_NR_BITS);
    eval 'sub TAG_CONTEXT_BITS () {(( &_AC(1, &UL) <<  &CTX_NR_BITS) -  &_AC(1, &UL));}' unless defined(&TAG_CONTEXT_BITS);
    eval 'sub CTX_VERSION_SHIFT () {22;}' unless defined(&CTX_VERSION_SHIFT);
    eval 'sub CTX_VERSION_MASK () {((~0) <<  &CTX_VERSION_SHIFT);}' unless defined(&CTX_VERSION_MASK);
    eval 'sub CTX_PGSZ_8KB () { &_AC(0x, &UL);}' unless defined(&CTX_PGSZ_8KB);
    eval 'sub CTX_PGSZ_64KB () { &_AC(0x1, &UL);}' unless defined(&CTX_PGSZ_64KB);
    eval 'sub CTX_PGSZ_512KB () { &_AC(0x2, &UL);}' unless defined(&CTX_PGSZ_512KB);
    eval 'sub CTX_PGSZ_4MB () { &_AC(0x3, &UL);}' unless defined(&CTX_PGSZ_4MB);
    eval 'sub CTX_PGSZ_BITS () { &_AC(0x7, &UL);}' unless defined(&CTX_PGSZ_BITS);
    eval 'sub CTX_PGSZ0_NUC_SHIFT () {61;}' unless defined(&CTX_PGSZ0_NUC_SHIFT);
    eval 'sub CTX_PGSZ1_NUC_SHIFT () {58;}' unless defined(&CTX_PGSZ1_NUC_SHIFT);
    eval 'sub CTX_PGSZ0_SHIFT () {16;}' unless defined(&CTX_PGSZ0_SHIFT);
    eval 'sub CTX_PGSZ1_SHIFT () {19;}' unless defined(&CTX_PGSZ1_SHIFT);
    eval 'sub CTX_PGSZ_MASK () {(( &CTX_PGSZ_BITS <<  &CTX_PGSZ0_SHIFT) | ( &CTX_PGSZ_BITS <<  &CTX_PGSZ1_SHIFT));}' unless defined(&CTX_PGSZ_MASK);
    if(defined( &CONFIG_SPARC64_PAGE_SIZE_8KB)) {
	eval 'sub CTX_PGSZ_BASE () { &CTX_PGSZ_8KB;}' unless defined(&CTX_PGSZ_BASE);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_64KB)) {
	eval 'sub CTX_PGSZ_BASE () { &CTX_PGSZ_64KB;}' unless defined(&CTX_PGSZ_BASE);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_512KB)) {
	eval 'sub CTX_PGSZ_BASE () { &CTX_PGSZ_512KB;}' unless defined(&CTX_PGSZ_BASE);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_4MB)) {
	eval 'sub CTX_PGSZ_BASE () { &CTX_PGSZ_4MB;}' unless defined(&CTX_PGSZ_BASE);
    } else {
	die("No\ page\ size\ specified\ in\ kernel\ configuration");
    }
    if(defined( &CONFIG_HUGETLB_PAGE_SIZE_4MB)) {
	eval 'sub CTX_PGSZ_HUGE () { &CTX_PGSZ_4MB;}' unless defined(&CTX_PGSZ_HUGE);
    }
 elsif(defined( &CONFIG_HUGETLB_PAGE_SIZE_512K)) {
	eval 'sub CTX_PGSZ_HUGE () { &CTX_PGSZ_512KB;}' unless defined(&CTX_PGSZ_HUGE);
    }
 elsif(defined( &CONFIG_HUGETLB_PAGE_SIZE_64K)) {
	eval 'sub CTX_PGSZ_HUGE () { &CTX_PGSZ_64KB;}' unless defined(&CTX_PGSZ_HUGE);
    }
    eval 'sub CTX_PGSZ_KERN () { &CTX_PGSZ_4MB;}' unless defined(&CTX_PGSZ_KERN);
    eval 'sub CTX_CHEETAH_PLUS_NUC () {(( &CTX_PGSZ_KERN <<  &CTX_PGSZ0_NUC_SHIFT) | ( &CTX_PGSZ_BASE <<  &CTX_PGSZ1_NUC_SHIFT));}' unless defined(&CTX_CHEETAH_PLUS_NUC);
    eval 'sub CTX_CHEETAH_PLUS_CTX0 () {(( &CTX_PGSZ_KERN <<  &CTX_PGSZ0_SHIFT) | ( &CTX_PGSZ_BASE <<  &CTX_PGSZ1_SHIFT));}' unless defined(&CTX_CHEETAH_PLUS_CTX0);
    eval 'sub CTX_NR_MASK () { &TAG_CONTEXT_BITS;}' unless defined(&CTX_NR_MASK);
    eval 'sub CTX_HW_MASK () {( &CTX_NR_MASK |  &CTX_PGSZ_MASK);}' unless defined(&CTX_HW_MASK);
    eval 'sub CTX_FIRST_VERSION () {(( &_AC(1, &UL) <<  &CTX_VERSION_SHIFT) +  &_AC(1, &UL));}' unless defined(&CTX_FIRST_VERSION);
    eval 'sub CTX_VALID {
        my($__ctx) = @_;
	    eval q((!((( ($__ctx->{sparc64_ctx_val})) ^  &tlb_context_cache) &  &CTX_VERSION_MASK)));
    }' unless defined(&CTX_VALID);
    eval 'sub CTX_HWBITS {
        my($__ctx) = @_;
	    eval q((( ($__ctx->{sparc64_ctx_val})) &  &CTX_HW_MASK));
    }' unless defined(&CTX_HWBITS);
    eval 'sub CTX_NRBITS {
        my($__ctx) = @_;
	    eval q((( ($__ctx->{sparc64_ctx_val})) &  &CTX_NR_MASK));
    }' unless defined(&CTX_NRBITS);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub TSB_ENTRY_ALIGNMENT () {16;}' unless defined(&TSB_ENTRY_ALIGNMENT);
	eval 'sub MM_TSB_BASE () {0;}' unless defined(&MM_TSB_BASE);
	if(defined(&CONFIG_HUGETLB_PAGE)) {
	    eval 'sub MM_TSB_HUGE () {1;}' unless defined(&MM_TSB_HUGE);
	    eval 'sub MM_NUM_TSBS () {2;}' unless defined(&MM_NUM_TSBS);
	} else {
	    eval 'sub MM_NUM_TSBS () {1;}' unless defined(&MM_NUM_TSBS);
	}
    }
    eval 'sub TSB_CONFIG_TSB () {0x;}' unless defined(&TSB_CONFIG_TSB);
    eval 'sub TSB_CONFIG_RSS_LIMIT () {0x8;}' unless defined(&TSB_CONFIG_RSS_LIMIT);
    eval 'sub TSB_CONFIG_NENTRIES () {0x10;}' unless defined(&TSB_CONFIG_NENTRIES);
    eval 'sub TSB_CONFIG_REG_VAL () {0x18;}' unless defined(&TSB_CONFIG_REG_VAL);
    eval 'sub TSB_CONFIG_MAP_VADDR () {0x20;}' unless defined(&TSB_CONFIG_MAP_VADDR);
    eval 'sub TSB_CONFIG_MAP_PTE () {0x28;}' unless defined(&TSB_CONFIG_MAP_PTE);
}
1;
