require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_PAGE_H)) {
    eval 'sub _SPARC64_PAGE_H () {1;}' unless defined(&_SPARC64_PAGE_H);
    require 'asm/const.ph';
    if(defined( &CONFIG_SPARC64_PAGE_SIZE_8KB)) {
	eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_64KB)) {
	eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_512KB)) {
	eval 'sub PAGE_SHIFT () {19;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_SPARC64_PAGE_SIZE_4MB)) {
	eval 'sub PAGE_SHIFT () {22;}' unless defined(&PAGE_SHIFT);
    } else {
	die("No\ page\ size\ specified\ in\ kernel\ configuration");
    }
    eval 'sub PAGE_SIZE () {( &_AC(1, &UL) <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    if((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) < 14) {
	eval 'sub DCACHE_ALIASING_POSSIBLE () {1;}' unless defined(&DCACHE_ALIASING_POSSIBLE);
    }
    if(defined(&__KERNEL__)) {
	if(defined( &CONFIG_HUGETLB_PAGE_SIZE_4MB)) {
	    eval 'sub HPAGE_SHIFT () {22;}' unless defined(&HPAGE_SHIFT);
	}
 elsif(defined( &CONFIG_HUGETLB_PAGE_SIZE_512K)) {
	    eval 'sub HPAGE_SHIFT () {19;}' unless defined(&HPAGE_SHIFT);
	}
 elsif(defined( &CONFIG_HUGETLB_PAGE_SIZE_64K)) {
	    eval 'sub HPAGE_SHIFT () {16;}' unless defined(&HPAGE_SHIFT);
	}
	if(defined(&CONFIG_HUGETLB_PAGE)) {
	    eval 'sub HPAGE_SIZE () {( &_AC(1, &UL) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
	    eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
	    eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
	    eval 'sub ARCH_HAS_SETCLEAR_HUGE_PTE () {1;}' unless defined(&ARCH_HAS_SETCLEAR_HUGE_PTE);
	    eval 'sub ARCH_HAS_HUGETLB_PREFAULT_HOOK () {1;}' unless defined(&ARCH_HAS_HUGETLB_PREFAULT_HOOK);
	    eval 'sub HAVE_ARCH_HUGETLB_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_HUGETLB_UNMAPPED_AREA);
	}
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub clear_page {
	        my($X) = @_;
    		eval q( &_clear_page(( &void *)($X)));
	    }' unless defined(&clear_page);
	    eval 'sub copy_page {
	        my($X,$Y) = @_;
    		eval q( &memcpy(( &void *)($X), ( &void *)($Y),  &PAGE_SIZE));
	    }' unless defined(&copy_page);
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    my($x) = @_;
    		    eval q((($x). &iopte));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    my($x) = @_;
    		    eval q((( &iopte_t) { ($x) } ));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub iopte_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&iopte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __iopte {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__iopte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
	    }
	    eval 'sub TASK_UNMAPPED_BASE () {( &test_thread_flag( &TIF_32BIT) ? ( &_AC(0x70000000, &UL)) : ( &_AC(1.84467352776165e+19, &UL) + (1 << 32)));}' unless defined(&TASK_UNMAPPED_BASE);
	    require 'asm-generic/memory_model.ph';
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub PAGE_OFFSET () { &_AC(1.84467352776165e+19, &UL);}' unless defined(&PAGE_OFFSET);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub __pa {
	        my($x) = @_;
    		eval q((($x) -  &PAGE_OFFSET));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        my($x) = @_;
    		eval q((( &void *)( ($x) +  &PAGE_OFFSET)));
	    }' unless defined(&__va);
	    eval 'sub pfn_to_kaddr {
	        my($pfn) = @_;
    		eval q( &__va(($pfn) <<  &PAGE_SHIFT));
	    }' unless defined(&pfn_to_kaddr);
	    eval 'sub virt_to_page {
	        my($kaddr) = @_;
    		eval q( &pfn_to_page( &__pa($kaddr)>> &PAGE_SHIFT));
	    }' unless defined(&virt_to_page);
	    eval 'sub virt_addr_valid {
	        my($kaddr) = @_;
    		eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_addr_valid);
	    eval 'sub virt_to_phys () { &__pa;}' unless defined(&virt_to_phys);
	    eval 'sub phys_to_virt () { &__va;}' unless defined(&phys_to_virt);
	}
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
    require 'asm-generic/page.ph';
}
1;
