require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_RWSEM_H)) {
    eval 'sub _SPARC64_RWSEM_H () {1;}' unless defined(&_SPARC64_RWSEM_H);
    unless(defined(&_LINUX_RWSEM_H)) {
	die("please don't include asm/rwsem.h directly, use linux/rwsem.h instead");
    }
    if(defined(&__KERNEL__)) {
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	require 'asm/rwsem-const.ph';
	eval 'sub __RWSEM_INITIALIZER {
	    my($name) = @_;
    	    eval q({  &RWSEM_UNLOCKED_VALUE,  &SPIN_LOCK_UNLOCKED,  &LIST_HEAD_INIT(($name). &wait_list) });
	}' unless defined(&__RWSEM_INITIALIZER);
	eval 'sub DECLARE_RWSEM {
	    my($name) = @_;
    	    eval q(1;
	}' unless defined(&DECLARE_RWSEM);
	eval 'sub init_rwsem {
	    my($sem) = @_;
    	    eval q({  ($sem->{count}) =  &RWSEM_UNLOCKED_VALUE;  &spin_lock_init( ($sem->{wait_lock}));  &INIT_LIST_HEAD( ($sem->{wait_list})); });
	}' unless defined(&init_rwsem);
	eval 'sub rwsem_atomic_update {
	    my($delta,$sem) = @_;
    	    eval q({  &atomic_add_return($delta, ( &atomic_t *)( ($sem->{count}))); });
	}' unless defined(&rwsem_atomic_update);
	eval 'sub rwsem_atomic_add {
	    my($delta,$sem) = @_;
    	    eval q({  &atomic_add($delta, ( &atomic_t *)( ($sem->{count}))); });
	}' unless defined(&rwsem_atomic_add);
	eval 'sub rwsem_is_locked {
	    my($sem) = @_;
    	    eval q({ ( ($sem->{count}) != 0); });
	}' unless defined(&rwsem_is_locked);
    }
}
1;
