require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_KOBJECT_H_)) {
    eval 'sub _KOBJECT_H_ () {1;}' unless defined(&_KOBJECT_H_);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'linux/list.ph';
	require 'linux/sysfs.ph';
	require 'linux/spinlock.ph';
	require 'linux/rwsem.ph';
	require 'linux/kref.ph';
	require 'linux/kernel.ph';
	require 'linux/wait.ph';
	require 'asm/atomic.ph';
	eval 'sub KOBJ_NAME_LEN () {20;}' unless defined(&KOBJ_NAME_LEN);
	eval 'sub UEVENT_HELPER_PATH_LEN () {256;}' unless defined(&UEVENT_HELPER_PATH_LEN);
	eval("sub KOBJ_ADD () { (__forcekobject_action_t)0x01; }") unless defined(&KOBJ_ADD);
	eval("sub KOBJ_REMOVE () { (__forcekobject_action_t)0x02; }") unless defined(&KOBJ_REMOVE);
	eval("sub KOBJ_CHANGE () { (__forcekobject_action_t)0x03; }") unless defined(&KOBJ_CHANGE);
	eval("sub KOBJ_MOUNT () { (__forcekobject_action_t)0x04; }") unless defined(&KOBJ_MOUNT);
	eval("sub KOBJ_UMOUNT () { (__forcekobject_action_t)0x05; }") unless defined(&KOBJ_UMOUNT);
	eval("sub KOBJ_OFFLINE () { (__forcekobject_action_t)0x06; }") unless defined(&KOBJ_OFFLINE);
	eval("sub KOBJ_ONLINE () { (__forcekobject_action_t)0x07; }") unless defined(&KOBJ_ONLINE);
	eval 'sub kobject_name {
	    my($kobj) = @_;
    	    eval q({  ($kobj->{k_name}); });
	}' unless defined(&kobject_name);
	eval 'sub to_kset {
	    my($kobj) = @_;
    	    eval q({ $kobj ?  &container_of($kobj,1; });
	}' unless defined(&to_kset);
	eval 'sub kset_get {
	    my($k) = @_;
    	    eval q({ $k ?  &to_kset( &kobject_get( ($k->{kobj}))) :  &NULL; });
	}' unless defined(&kset_get);
	eval 'sub kset_put {
	    my($k) = @_;
    	    eval q({  &kobject_put( ($k->{kobj})); });
	}' unless defined(&kset_put);
	eval 'sub get_ktype {
	    my($k) = @_;
    	    eval q({  &if ( ($k->{kset})  &&  ($k->{kset}->{ktype}))  ($k->{kset}->{ktype});  &else  ($k->{ktype}); });
	}' unless defined(&get_ktype);
	eval 'sub set_kset_name {
	    my($str) = @_;
    	    eval q(. &kset = { . &kobj = { . &name = $str } });
	}' unless defined(&set_kset_name);
	eval 'sub decl_subsys {
	    my($_name,$_type,$_uevent_ops) = @_;
    	    eval q(1;
	}' unless defined(&decl_subsys);
	eval 'sub decl_subsys_name {
	    my($_varname,$_name,$_type,$_uevent_ops) = @_;
    	    eval q(1;
	}' unless defined(&decl_subsys_name);
	eval 'sub kobj_set_kset_s {
	    my($obj,$subsys) = @_;
    	    eval q(($obj)-> ($k$obj->{kset}) = ($subsys). &kset);
	}' unless defined(&kobj_set_kset_s);
	eval 'sub kset_set_kset_s {
	    my($obj,$subsys) = @_;
    	    eval q(($obj)-> ($kset->{k$obj}->{kset}) = ($subsys). &kset);
	}' unless defined(&kset_set_kset_s);
	eval 'sub subsys_set_kset {
	    my($obj,$_subsys) = @_;
    	    eval q(($obj)-> ($subsys->{kset}->{k$obj}->{kset}) = ($_subsys). &kset);
	}' unless defined(&subsys_set_kset);
	eval 'sub subsys_get {
	    my($s) = @_;
    	    eval q({ $s ?  &container_of( &kset_get( ($s->{k$set})),1; });
	}' unless defined(&subsys_get);
	eval 'sub subsys_put {
	    my($s) = @_;
    	    eval q({  &kset_put( ($s->{k$set})); });
	}' unless defined(&subsys_put);
	if(defined( &CONFIG_HOTPLUG)) {
	} else {
	    eval 'sub add_uevent_var {
	        my($envp,$num_envp,$cur_index,$buffer,$buffer_size,$cur_len,$format) = @_;
    		eval q({ 0; });
	    }' unless defined(&add_uevent_var);
	}
    }
}
1;
