require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MODULE_PARAMS_H)) {
    eval 'sub _LINUX_MODULE_PARAMS_H () {1;}' unless defined(&_LINUX_MODULE_PARAMS_H);
    require 'linux/init.ph';
    require 'linux/stringify.ph';
    require 'linux/kernel.ph';
    if(defined(&MODULE)) {
	eval 'sub MODULE_PARAM_PREFIX () {1;}' unless defined(&MODULE_PARAM_PREFIX);
    } else {
	eval 'sub MODULE_PARAM_PREFIX () { &KBUILD_MODNAME ".";}' unless defined(&MODULE_PARAM_PREFIX);
    }
    if(defined(&MODULE)) {
	eval 'sub ___module_cat {
	    my($a,$b) = @_;
    	    eval q( &__mod_  $a  $b);
	}' unless defined(&___module_cat);
	eval 'sub __module_cat {
	    my($a,$b) = @_;
    	    eval q( &___module_cat($a,$b));
	}' unless defined(&__module_cat);
	eval 'sub __MODULE_INFO {
	    my($tag, $name, $info) = @_;
    	    eval q( &static  &const \'char\'  &__module_cat($name, &__LINE__)[]  &__attribute_used__  &__attribute__(( &section(\\".modinfo\\"), &unused)) =  &__stringify($tag) \\"=\\" $info);
	}' unless defined(&__MODULE_INFO);
    } else {
	eval 'sub __MODULE_INFO {
	    my($tag, $name, $info) = @_;
    	    eval q();
	}' unless defined(&__MODULE_INFO);
    }
    eval 'sub __MODULE_PARM_TYPE {
        my($name, $_type) = @_;
	    eval q( &__MODULE_INFO( &parmtype, $name &type, $name \\":\\" $_type));
    }' unless defined(&__MODULE_PARM_TYPE);
    eval 'sub __module_param_call {
        my($prefix, $name, $set, $get, $arg, $perm) = @_;
	    eval q( &static \'char\'  &__param_str_$name->[] = $prefix $name;  &static 1;
    }' unless defined(&__module_param_call);
    eval 'sub module_param_call {
        my($name, $set, $get, $arg, $perm) = @_;
	    eval q( &__module_param_call( &MODULE_PARAM_PREFIX, $name, $set, $get, $arg, $perm));
    }' unless defined(&module_param_call);
    eval 'sub module_param_named {
        my($name, $value, $type, $perm) = @_;
	    eval q( &param_check_$type($name, ($value));  &module_param_call($name,  &param_set_$type,  &param_get_$type, $value, $perm);  &__MODULE_PARM_TYPE($name, $type));
    }' unless defined(&module_param_named);
    eval 'sub module_param {
        my($name, $type, $perm) = @_;
	    eval q( &module_param_named($name, $name, $type, $perm));
    }' unless defined(&module_param);
    eval 'sub module_param_string {
        my($name, $string, $len, $perm) = @_;
	    eval q( &static 1;  &module_param_call($name,  &param_set_copystring,  &param_get_string, & &__param_string_$name, $perm);  &__MODULE_PARM_TYPE($name, \\"string\\"));
    }' unless defined(&module_param_string);
    eval 'sub __param_check {
        my($name, $p, $type) = @_;
	    eval q( &static  &inline $type * &__check_$name( &void) {  &return($p); });
    }' unless defined(&__param_check);
    eval 'sub param_check_byte {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'unsigned char\'));
    }' unless defined(&param_check_byte);
    eval 'sub param_check_short {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'short\'));
    }' unless defined(&param_check_short);
    eval 'sub param_check_ushort {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'unsigned short\'));
    }' unless defined(&param_check_ushort);
    eval 'sub param_check_int {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'int\'));
    }' unless defined(&param_check_int);
    eval 'sub param_check_uint {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'unsigned int\'));
    }' unless defined(&param_check_uint);
    eval 'sub param_check_long {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'long\'));
    }' unless defined(&param_check_long);
    eval 'sub param_check_ulong {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'unsigned long\'));
    }' unless defined(&param_check_ulong);
    eval 'sub param_check_charp {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'char\' *));
    }' unless defined(&param_check_charp);
    eval 'sub param_check_bool {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'int\'));
    }' unless defined(&param_check_bool);
    eval 'sub param_check_invbool {
        my($name, $p) = @_;
	    eval q( &__param_check($name, $p, \'int\'));
    }' unless defined(&param_check_invbool);
    eval 'sub module_param_array_named {
        my($name, $array, $type, $nump, $perm) = @_;
	    eval q( &static 1;  &module_param_call($name,  &param_array_set,  &param_array_get, & &__param_arr_$name, $perm);  &__MODULE_PARM_TYPE($name, \\"array of \\" $type));
    }' unless defined(&module_param_array_named);
    eval 'sub module_param_array {
        my($name, $type, $nump, $perm) = @_;
	    eval q( &module_param_array_named($name, $name, $type, $nump, $perm));
    }' unless defined(&module_param_array);
}
1;
