require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NOTIFIER_H)) {
    eval 'sub _LINUX_NOTIFIER_H () {1;}' unless defined(&_LINUX_NOTIFIER_H);
    require 'linux/errno.ph';
    require 'linux/mutex.ph';
    require 'linux/rwsem.ph';
    eval 'sub ATOMIC_INIT_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q( &do {  &spin_lock_init(($name)-> &lock); ($name)-> &head =  &NULL; }  &while (0));
    }' unless defined(&ATOMIC_INIT_NOTIFIER_HEAD);
    eval 'sub BLOCKING_INIT_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q( &do {  &init_rwsem(($name)-> &rwsem); ($name)-> &head =  &NULL; }  &while (0));
    }' unless defined(&BLOCKING_INIT_NOTIFIER_HEAD);
    eval 'sub RAW_INIT_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q( &do { ($name)-> &head =  &NULL; }  &while (0));
    }' unless defined(&RAW_INIT_NOTIFIER_HEAD);
    eval 'sub ATOMIC_NOTIFIER_INIT {
        my($name) = @_;
	    eval q({ . &lock =  &__SPIN_LOCK_UNLOCKED( ($name->{lock})), . &head =  &NULL });
    }' unless defined(&ATOMIC_NOTIFIER_INIT);
    eval 'sub BLOCKING_NOTIFIER_INIT {
        my($name) = @_;
	    eval q({ . &rwsem =  &__RWSEM_INITIALIZER(($name). &rwsem), . &head =  &NULL });
    }' unless defined(&BLOCKING_NOTIFIER_INIT);
    eval 'sub RAW_NOTIFIER_INIT {
        my($name) = @_;
	    eval q({ . &head =  &NULL });
    }' unless defined(&RAW_NOTIFIER_INIT);
    eval 'sub ATOMIC_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q(1;
    }' unless defined(&ATOMIC_NOTIFIER_HEAD);
    eval 'sub BLOCKING_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q(1;
    }' unless defined(&BLOCKING_NOTIFIER_HEAD);
    eval 'sub RAW_NOTIFIER_HEAD {
        my($name) = @_;
	    eval q(1;
    }' unless defined(&RAW_NOTIFIER_HEAD);
    if(defined(&__KERNEL__)) {
	eval 'sub NOTIFY_DONE () {0x;}' unless defined(&NOTIFY_DONE);
	eval 'sub NOTIFY_OK () {0x1;}' unless defined(&NOTIFY_OK);
	eval 'sub NOTIFY_STOP_MASK () {0x8000;}' unless defined(&NOTIFY_STOP_MASK);
	eval 'sub NOTIFY_BAD () {( &NOTIFY_STOP_MASK|0x2);}' unless defined(&NOTIFY_BAD);
	eval 'sub NOTIFY_STOP () {( &NOTIFY_OK| &NOTIFY_STOP_MASK);}' unless defined(&NOTIFY_STOP);
	eval 'sub NETDEV_UP () {0x1;}' unless defined(&NETDEV_UP);
	eval 'sub NETDEV_DOWN () {0x2;}' unless defined(&NETDEV_DOWN);
	eval 'sub NETDEV_REBOOT () {0x3;}' unless defined(&NETDEV_REBOOT);
	eval 'sub NETDEV_CHANGE () {0x4;}' unless defined(&NETDEV_CHANGE);
	eval 'sub NETDEV_REGISTER () {0x5;}' unless defined(&NETDEV_REGISTER);
	eval 'sub NETDEV_UNREGISTER () {0x6;}' unless defined(&NETDEV_UNREGISTER);
	eval 'sub NETDEV_CHANGEMTU () {0x7;}' unless defined(&NETDEV_CHANGEMTU);
	eval 'sub NETDEV_CHANGEADDR () {0x8;}' unless defined(&NETDEV_CHANGEADDR);
	eval 'sub NETDEV_GOING_DOWN () {0x9;}' unless defined(&NETDEV_GOING_DOWN);
	eval 'sub NETDEV_CHANGENAME () {0xa;}' unless defined(&NETDEV_CHANGENAME);
	eval 'sub NETDEV_FEAT_CHANGE () {0xb;}' unless defined(&NETDEV_FEAT_CHANGE);
	eval 'sub SYS_DOWN () {0x1;}' unless defined(&SYS_DOWN);
	eval 'sub SYS_RESTART () { &SYS_DOWN;}' unless defined(&SYS_RESTART);
	eval 'sub SYS_HALT () {0x2;}' unless defined(&SYS_HALT);
	eval 'sub SYS_POWER_OFF () {0x3;}' unless defined(&SYS_POWER_OFF);
	eval 'sub NETLINK_URELEASE () {0x1;}' unless defined(&NETLINK_URELEASE);
	eval 'sub CPU_ONLINE () {0x2;}' unless defined(&CPU_ONLINE);
	eval 'sub CPU_UP_PREPARE () {0x3;}' unless defined(&CPU_UP_PREPARE);
	eval 'sub CPU_UP_CANCELED () {0x4;}' unless defined(&CPU_UP_CANCELED);
	eval 'sub CPU_DOWN_PREPARE () {0x5;}' unless defined(&CPU_DOWN_PREPARE);
	eval 'sub CPU_DOWN_FAILED () {0x6;}' unless defined(&CPU_DOWN_FAILED);
	eval 'sub CPU_DEAD () {0x7;}' unless defined(&CPU_DEAD);
    }
}
1;
