require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_TYPES_H)) {
    eval 'sub _LINUX_TYPES_H () {1;}' unless defined(&_LINUX_TYPES_H);
    unless(defined(&__KERNEL__)) {
	require 'sys/types.ph';
	require 'linux/posix_types.ph';
	require 'asm/types.ph';
    } else {
	if(defined(&__KERNEL__)) {
	    eval 'sub BITS_TO_LONGS {
	        my($bits) = @_;
    		eval q(((($bits)+ &BITS_PER_LONG-1)/ &BITS_PER_LONG));
	    }' unless defined(&BITS_TO_LONGS);
	    eval 'sub DECLARE_BITMAP {
	        my($name,$bits) = @_;
    		eval q(\'unsigned long name\'[ &BITS_TO_LONGS($bits)]);
	    }' unless defined(&DECLARE_BITMAP);
	    eval 'sub BITS_PER_BYTE () {8;}' unless defined(&BITS_PER_BYTE);
	}
	require 'linux/posix_types.ph';
	require 'asm/types.ph';
	unless(defined(&__KERNEL_STRICT_NAMES)) {
	    if(defined(&__KERNEL__)) {
		if(defined(&CONFIG_UID16)) {
		}
	    } else {
	    }
	    if(defined( &__GNUC__)  && !defined( &__STRICT_ANSI__)) {
	    }
	    unless(defined(&_SIZE_T)) {
		eval 'sub _SIZE_T () {1;}' unless defined(&_SIZE_T);
	    }
	    unless(defined(&_SSIZE_T)) {
		eval 'sub _SSIZE_T () {1;}' unless defined(&_SSIZE_T);
	    }
	    unless(defined(&_PTRDIFF_T)) {
		eval 'sub _PTRDIFF_T () {1;}' unless defined(&_PTRDIFF_T);
	    }
	    unless(defined(&_TIME_T)) {
		eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
	    }
	    unless(defined(&_CLOCK_T)) {
		eval 'sub _CLOCK_T () {1;}' unless defined(&_CLOCK_T);
	    }
	    unless(defined(&_CADDR_T)) {
		eval 'sub _CADDR_T () {1;}' unless defined(&_CADDR_T);
	    }
	    unless(defined(&__BIT_TYPES_DEFINED__)) {
		eval 'sub __BIT_TYPES_DEFINED__ () {1;}' unless defined(&__BIT_TYPES_DEFINED__);
	    }
	    if(defined( &__GNUC__)  && !defined( &__STRICT_ANSI__)) {
	    }
	    eval 'sub aligned_u64 () { &unsigned long long __attribute__(( &aligned(8)));}' unless defined(&aligned_u64);
	    unless(defined(&HAVE_SECTOR_T)) {
	    }
	    unless(defined(&HAVE_BLKCNT_T)) {
	    }
	    unless(defined(&pgoff_t)) {
		eval 'sub pgoff_t () {\'unsigned long\';}' unless defined(&pgoff_t);
	    }
	}
    }
    if(defined(&__CHECKER__)) {
	eval 'sub __bitwise__ () { &__attribute__(( &bitwise));}' unless defined(&__bitwise__);
    } else {
	eval 'sub __bitwise__ () {1;}' unless defined(&__bitwise__);
    }
    if(defined(&__CHECK_ENDIAN__)) {
	eval 'sub __bitwise () { &__bitwise__;}' unless defined(&__bitwise);
    } else {
	eval 'sub __bitwise () {1;}' unless defined(&__bitwise);
    }
    if(defined( &__GNUC__)) {
    }
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_RESOURCES_64BIT)) {
	} else {
	}
    }
    if(0) {
    }
}
1;
